{-# LANGUAGE NoMonomorphismRestriction #-}
import Data.Monoid (mempty)
import Test.Framework (
  Test,
  defaultMainWithOpts,
  )
import Test.Framework.Options
import Test.Framework.Runners.Options

import Cidr (cidr_properties, cidr_tests)

import IPv4Address (ipv4address_tests)
import Octet (octet_tests)

tests :: [Test.Framework.Test]
tests = [ cidr_properties,
          cidr_tests,
          ipv4address_tests,
          octet_tests ]

main :: IO ()
main = do
  let empty_test_opts = mempty :: TestOptions
  let my_test_opts = empty_test_opts {
    --
    -- Increase to 5000 when,
    --   https://github.com/batterseapower/test-framework/issues/34
    -- is fixed.
    --
    topt_maximum_generated_tests = Just 1000
  }
  let empty_runner_opts = mempty :: RunnerOptions
  let my_runner_opts = empty_runner_opts {
    ropt_test_options = Just my_test_opts
  }

  defaultMainWithOpts tests my_runner_opts
